// Importer la librairie oscP5
// netP5 est indispensable aussi
import oscP5.*;
import netP5.*;

OscP5 oscP5;

PImage camo, nuage;

int smallPoint = 2;
int largePoint;

void setup() {

  // Parametres graphiques
  size(512, 512);

  camo = loadImage("camomille.jpg");
  nuage = loadImage("nuage.jpg");

  background(255);
  smooth();
  largePoint = min(width, height) / 10;

  // Demarrer oscP5
  oscP5 = new OscP5(this, 2200);
}


/* Reception de messages OSC envoyes par PD
/* Incoming OSC messages from PD. */
float hysteresis, capteur;

void oscEvent(OscMessage message_PD) {
  /* Trie les messages arrivant en fonction de leur adresse
   * Check the address pattern of the received OscMessage */
  /* Attention aux types de variables envoyees depuis PD, int ou float.
  /* Beware the PD variable type, int or float 
   */

  // Comparateur a hysteresis
  if (message_PD.checkAddrPattern("/hyst")==true) {
    hysteresis = message_PD.get(0).intValue();
    println(" Message /hyst : "+ hysteresis);
  }

  // Valeurs du capteur
  if (message_PD.checkAddrPattern("/capt")==true) {
    capteur = float(message_PD.get(0).intValue());
    println(" Message /capt : "+ capteur);
  }
}


void draw() {

  // Proche du capteur
  if (hysteresis == 1) {
    float pointillize = map(capteur, 52, 127, smallPoint, largePoint);
    int x = int(random(camo.width));
    int y = int(random(camo.height));
    color pix = camo.get(x, y);
    stroke(0);
    fill(pix, 128);
    ellipse(x, y, pointillize, pointillize);
  }
  
  // Loin du capteur
  if (hysteresis == 0) {
    float pointillize = map(capteur, 0, 68, smallPoint, largePoint);
    int x = int(random(nuage.width));
    int y = int(random(nuage.height));
    color pix = nuage.get(x, y);
    noStroke();
    fill(pix, 128);
    ellipse(x, y, pointillize, pointillize);
  }
}

